
#include "trayicon_x11.h"

#include <qwindowdefs.h>
#include <qlabel.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <stdio.h>

#include "debug.h"

bool TrayIcon::sysSupported()
{
	/* Detect if KDE+Kicker+Tray Plugin are running */
	int result;
	FILE* stream = popen("dcop kicker > /dev/null 2>&1 ; echo $?","r");
	fscanf(stream,"%d", &result);
	fclose(stream);
	if (result == 0) return true;
	else
	{
		xDebug("KDE Kicker not running, tray icon not supported.");
		return false;
	}
}

void TrayIcon::sysInstall()
{
	if (!sysSupported())
	{
		return;
	}
    	if ( d )
		return;

	Atom kde_net_wm_system_tray_window_for = XInternAtom( qt_xdisplay(), "_KDE_NET_WM_SYSTEM_TRAY_WINDOW_FOR", false);
	d = new TrayIconPrivate( this );

	// Set the pixmap
	d->setPixmap(pm);

	WId trayWin =d->winId();
	WId forWin = d->winId();

	XChangeProperty( qt_xdisplay(), trayWin, kde_net_wm_system_tray_window_for, XA_WINDOW, 32,
        					PropModeReplace, (unsigned char *)&forWin, 1);
//	qDebug("%d",(int)kde_net_wm_system_tray_window_for);
	d->show();
}

void TrayIcon::sysRemove()
{
    	if ( !d )
		return;

	d->hide();
    	delete d;
    	d = 0;
}

void TrayIcon::sysUpdateIcon()
{
    	if ( !d )
		return;

	d->setPixmap(pm);
 }

void TrayIcon::sysUpdateToolTip()
{
    	if ( !d )
		return;
	xDebug("sysUpdateToolTip not yet implemented for X11 version");
}


